<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
</head>

<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    $(document).ready(function () {
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */


        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        onPageLoading();

        $(document).on("click", ".btn-edit", function () {
            onBtnEditClick(this);
        })

        $(document).on("click", ".btn-delete", function () {
            onBtnDeleteClick(this);
        })

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

        function onPageLoading() {
            "use strict";
            console.log("tải trang thành công");

            $.ajax({
                url: "http://203.171.20.210:8080/crud-api/users/",
                type: 'GET',
                dataType: 'json', // added data type
                success: function (data) {
                    console.log(data);
                    fillDataToTable(data);
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText);
                }
            });
        }

        function onBtnEditClick(paramEdit) {
            console.log("nút sửa đã được click");
            var vId = $(paramEdit).data("id");
            console.log("Id :" + vId);
        }

        function onBtnDeleteClick(paramDelete) {
            console.log("nút xoá đã được click");
            var vId = $(paramDelete).data("id");
            console.log("Id :" + vId);
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

        //hàm đổ dữ liệu vào table

        //input : là dữ liệu cần đổ vào bảng
        function fillDataToTable(paramData) {
            "use strict";

            for (var bI = 0; bI < paramData.length; bI++) {
                var vRow = "";
                vRow += "<tr>";
                    vRow += "<td>" + paramData[bI].id + "</td>";
                    vRow += "<td>" + paramData[bI].firstname + "</td>";
                    vRow += "<td>" + paramData[bI].lastname + "</td>";
                    vRow += "<td>" + paramData[bI].country + "</td>";
                    vRow += "<td>" + paramData[bI].subject + "</td>";
                    vRow += "<td>" + paramData[bI].customerType + "</td>";
                    vRow += "<td>" + paramData[bI].registerStatus + "</td>";
                    vRow += "<td><button class='btn btn-primary btn-edit' data-id = '" + paramData[bI].id + "'>Sửa</button><button class='btn btn-danger btn-delete' data-id = '" + paramData[bI].id + "'>Xoá</button></td>";
                    vRow += "</tr>";


                $('#table-users tbody').append(vRow);
            }


        }

    })


</script>

</html>